# PanParser #

An implementation of a transition-based dependency parser and PoS
tagger, with a modular design allowing numerous customizations.
Additionally, several wrappers, data transformation routines and I/O
utilities are included.

## Basic usage ##

The parser can be used either as an imported library (see
`read_conll`, `train_dependency_parser`, `process_dependency_parser`
and `eval_depency_parser` functions of file `dependency_parser.py`),
or through command-line:

`python3 dependency_parser.py --system ArcEager --strategy greedyn
--epoch 20 --trainset /path/to/train.conll --devset
/path/to/dev.conll --testset /path/to/test.conll --model
/path/to/model.pickle --train --validate --eval --showprogress`

`system` can be for instance: ArcHybridLabeled, ArcEagerPartial,
NonMonotonicArcEagerLabeled, and other combinations.

The tagger library is located in file `tagger/postagger.py`.

## Disclaimer ##

PanParser is still undergoing important developments, with major
changes on a daily basis.

The current version is then presented as is: it is functional for the
major uses (eg. training and evaluating on predicted PoS a labeled
arc-eager parser with an average perceptron and global dynamic
oracles), but some other parts of the code are still experimental, and
the documentation may be either incomplete, or outdated.

## Dependencies ##

The core library (i.e. the parser) does not rely on any external
library. However, the following dependency is required to show a
progress bar:

* [frogress](https://pypi.python.org/pypi/frogress/0.9.1)
