from .AbstractParser import AbstractParser

from structured_prediction.AbstractStructuredPredictor import Callback

class CombineParser(AbstractParser):
    def __init__(self, *a, parts=[], **kw):
        self.parts = parts
        super().__init__(*a, **kw)

    def _defaultmodel(self, *a, **kw): pass

    def learn(self, blackbox, sample, **kwargs): pass
    def search(self, blackbox, sample, **kwargs): pass

    def process_sample(self, sample, batched=False, **kwargs):
        from .mst import maximum_spanning_tree
        parts = (p.process_sample(sample, batched=batched, **kwargs) for p,_ in self.parts)
        combine = lambda parts: (maximum_spanning_tree((h,w) for (h,_),(_,w) in zip(map(next,parts), self.parts)), None)
        askbest = lambda hyp: iter([hyp])
        if batched:
            return [askbest(combine(parts)) for parts in zip(*parts)]
        return askbest(combine(parts))
