from .labeled_parser import LabeledParser
from .neural_parser import FeedForwardParser

class LabeledFeedForwardParser(LabeledParser, FeedForwardParser):

    def __init__(self, *a, **kw):
        kw['main'] = FeedForwardParser
        super().__init__(*a, **kw)

    def _joint_models(self, main, *args, **kwargs):
        main, auxiliary = super()._joint_models(main, *args, **kwargs)
        shared = main.model.layers[-2].output
        last = auxiliary.model.layers[-1]
        from keras.models import Model
        loss, optimizer = auxiliary.model.loss, auxiliary.model.optimizer
        auxiliary.model = Model(input=main.model.input, output=last(shared))
        auxiliary.model.compile(loss=loss, optimizer=optimizer)
        return (main, auxiliary)
