from .joint_parser import JointParser

class LabeledParser(JointParser):
    def __init__(self, feature_template, *a, **kw):
        from functools import partial
        feature_template = partial(feature_template, labeled=True) #
        super().__init__(feature_template, *a, **kw)

    joint_names = ['label']

    def _joint_models(self, main, dataset, *args, **kwargs):
        labels = sorted(list(set(l for ex in dataset for l in ex[-1] if l)))
        kwargs['classes'] = labels
        auxiliary = self.main_class._defaultmodel(self, dataset, *args, **kwargs)
        return (main, auxiliary)

    @staticmethod
    def _joint_update_configs():
        def labels(parse, gold):
            last_label = parse.__dict__.get('last_label')
            if type(last_label) != tuple: return
            i, guess = last_label
            _X, _, _ = parse.previous.configuration #
            # dynamic along
            best = gold[i]
            if best is not None: return best, guess, _X
        return [labels]
