from .preprocess import children, depths, infix

def display_constituents(data, heads, listener=Listener):
    const = ["(" if node == "__OPEN__" else ")" if node == "__CLOSE__" else data[node] for node in infix(children(heads))]
    listener.msg(' '.join(const[3:-3]))

def display_tree(data, heads, data2=None, depth=None, listener=Listener, crop=150):
    data = [(x,y,max(len(x),len(y),3)) for x,y in zip(data,data2 if data2 else data)]
    data = [(x.ljust(l-int((l-len(x))/2)).rjust(l),y.ljust(l-int((l-len(y))/2)).rjust(l)) for x,y,l in data]
    pos = []
    L = 0
    for x,y in data:
        l = max(len(x),len(y))
        pos.append(L + int(l / 2))
        L += l + 1
    data = tuple(zip(*data))[:1 if data2 is None else 2]

    _children = children(heads)
    _depths = depths(heads, _children)
    D = max(_depths) + 1
    if depth is not None: D = min(D,depth+1)
    ascii = [[" " for _ in range(L)] for _ in range(D+2)]

    for i,d in enumerate(_depths):
        if heads[i] is not None and 0 <= d < D:
            ascii[-1][pos[i]] = "ˇ"
            for j in range(d,D): ascii[j+1][pos[i]] = "|"
        if -1 <= d < D-1 and _children[i]:
            m, M = min(_children[i]), max(_children[i])
            if m < i:
                for j in range(d,D): ascii[j+2][pos[i]-1] = "|"
                for j in range(pos[m]+1,pos[i]-1): ascii[d+1][j] = "_"
            if M > i:
                for j in range(d,D): ascii[j+2][pos[i]+1] = "|"
                for j in range(pos[i]+2,pos[M]): ascii[d+1][j] = "_"

    lines = ["".join(line) for line in ascii] + [" ".join(d) for d in data]

    listener.msgs(lines, crop)
