from misc.misc import DefaultList
from pan4.format import pad_tokens

def rt(fha, fhs=None, fht=None, max_sent=None, rt=lambda x:(x.split() for x in x), **kwargs):
    notext = fhs is None
    if notext:
        from itertools import tee
        fha, fhs, fht = tee(fha, 3)
    for i, (aline, sline, tline) in enumerate(zip(fha, rt(fhs), rt(fht))):
        if i==max_sent: break
        aline = [tuple(int(i) for i in p.split("-")) for p in aline.split()]
        yield aline if notext else (sline, tline, aline)

def wt(*a, **kw):
    for _ in lazy_wt(*a, **kw): pass

def lazy_wt(dataset, fha, fhs=None, fht=None, preprocess=lambda x:x, lazy_wt=lambda fh, x, **_: x, **kwargs):
    notext = fhs is None
    if notext:
        align = dataset
    else:
        from misc.itertools import unzip_longest
        src, tgt, align = unzip_longest(dataset, batched=3)
        from conll.io import lazy_wt
        src = lazy_wt(fhs, src, preprocess=preprocess)
        tgt = lazy_wt(fht, tgt, preprocess=preprocess)
    align = ((fha.write(" ".join("{}-{}".format(*link) for link in al) + "\n"), al)[1] for al in align)
    return align if notext else zip(src, tgt, align)

def lazy_rt(f_load, s_fn, t_fn, a_fn, forced=False, **kwargs):
    from functools import partial
    try:
        if forced: raise FileNotFoundError
        with open(s_fn, "rt", encoding="utf-8", errors="replace") as fhs, open(t_fn, "rt", encoding="utf-8", errors="replace") as fht, open(a_fn, "rt", encoding="utf-8", errors="replace") as fha:
            yield from rt(fha, fhs, fht, **kwargs)
    except FileNotFoundError:
        with open(s_fn, "wt", encoding="utf-8", errors="replace") as fhs, open(t_fn, "wt", encoding="utf-8", errors="replace") as fht, open(a_fn, "wt", encoding="utf-8", errors="replace") as fha:
            yield from lazy_wt(f_load(), fha, fhs, fht, **kwargs)
