def feature_kldiv(model_fn, obs_fn):
    import math
    from misc.io import read_pickle
    with open(model_fn, "rb") as model_fh, open(obs_fn, "rb") as obs_fh:
        model = defaultdict(int)
        features_to_add = []
        for features in read_pickle(model_fh):
            if type(features)==int or features=={}:
                #
                if type(features)==int: features += 8
                if features: features_to_add = features_to_add[:-features]
                for features in features_to_add:
                    for f in features: model[f] += 1
                features_to_add = []
            else:
                features_to_add.append(features)

        if features_to_add:
            for features in features_to_add:
                for f in features: model[f] += 1

        obs = defaultdict(int)
        n_ex = 0
        for features in read_pickle(obs_fh):
            n_ex += 1
            for f in features:
                obs[f] += 1

        for f in model.keys() | obs.keys():
            model[f] += 0.1
            obs[f] += 0.1

        n = sum(model.values())
        model = { key: value / n for key, value in model.items() }
        n = sum(obs.values())
        obs = { key: value / n for key, value in obs.items() }

        return n_ex, sum(value * (math.log(value) - math.log(model.get(key))) for key, value in obs.items())

def distributions_between(m1_fn, m2_fn, m3_fn):
    import math
    from misc.io import read_pickle
    with open(m1_fn, "rb") as m1_fh, open(m2_fn, "rb") as m2_fh, open(m3_fn, "rb") as m3_fh:
        m1 = defaultdict(int)
        for features in read_pickle(m1_fh):
            for f in features:
                m1[f] += 1

        m2 = defaultdict(int)
        for features in read_pickle(m2_fh):
            for f in features:
                m2[f] += 1

        m3 = defaultdict(int)
        for features in read_pickle(m3_fh):
            for f in features:
                m3[f] += 1

        for f in m1.keys() | m2.keys() | m3.keys():
            m1[f] += 0.1
            m2[f] += 0.1
            m3[f] += 0.1

        n = sum(m1.values())
        m1 = { key: value / n for key, value in m1.items() }
        n = sum(m2.values())
        m2 = { key: value / n for key, value in m2.items() }
        n = sum(m3.values())
        m3 = { key: value / n for key, value in m3.items() }

        return sum(1 for k in m1.keys() if m1[k] <= m2[k] <= m3[k] or m1[k] >= m2[k] >= m3[k]) / len(m1)
